#include "myipc.h"
/* Threads */
#include <pthread.h>
#include <stdlib.h>
pthread_t       threadread, threadwrite;

/* read from Messagequeue */
void msg_read(mqd_t *mqd)
{
  int lgt,n;
  char buf[128];
  unsigned prio;
  struct mq_attr attr;

  while(1) {
          mq_getattr(*mqd,&attr);
          if ((lgt=mq_receive(*mqd,buf,attr.mq_msgsize,&prio)) <= 0) break;
          write (1,"\n",1);
          write(1,buf,lgt);
          write(1,"c> ",3);
  }
  pthread_cancel(threadwrite);
  n=0;
  pthread_exit(&n);
}

/* write in Messagequeue */
void msg_write( mqd_t *mqd)
{
  int lgt,n;
  char buf[128];
  unsigned prio;

  while (1) {
    prio=REC;
    write(1,"C> ",3);
    if ((lgt = read(0,buf,80)) <= 0) break;
    if (mq_send(*mqd,buf,lgt,prio) < 0) break;
  }
  err_sys("error mq_send");
  pthread_cancel(threadread);
  n=0;
  pthread_exit(&n);
}


int main(int argc, char *argv[])
{
  int c,flags;
  char second[128];
  mqd_t mqdw, mqdr;

  while ( (c = getopt(argc, argv, "n")) != -1) {
    switch (c) {
       case 'n': flags |= O_NONBLOCK;
                  break;
    }
  }
  if (optind != argc - 1)
       err_quit("usage: client [ -n ] <name>");
  flags = O_RDONLY;
  if ((mqdr = mq_open(argv[optind], flags)) <0 ) {
      err_sys("error mq_open - read");
  }
  strcpy(second,argv[optind]);
  strcat(second,"1");
  flags = O_WRONLY;
  if ((mqdw = mq_open(second, flags)) <0 ) {
      err_sys("error mq_open - write");
  }
  pthread_create(&threadread,NULL, (void *) msg_read,
                 (void *) &mqdr );
  pthread_create(&threadwrite,NULL, (void *) msg_write, 
                  (void *) &mqdw );
  pthread_join(threadread, NULL);
  pthread_join(threadwrite, NULL);
  exit(0);
}
