#include        "myipc.h"
struct mq_attr attr;

void mqread(mqd_t mqd,char *name)
{
  unsigned prio;
  char buffer[100];
  int n;
 
  while (1) {
    n = mq_receive(mqd, (char *)buffer, 100, &prio);
    if (n<=0) break;
    buffer[n]=0;
    write(1,"\n",1); write(1,buffer,n);
    write(1,"c> ",3);
  }
  mq_close(mqd);
  mq_unlink(name);
  exit(0);
}

void mqwrite(mqd_t mqd,char *name)
{
  unsigned prio;
  char buffer[100];
  int n;
 
  while (1) {
    write(1,"C> ",3);
    n=read(0,buffer,100);
    if (n<=0) break;
    prio=1;
    mq_send(mqd, buffer,n, prio);
  }
  mq_close(mqd);
  mq_unlink(name);
  exit(0);
}

int main(int argc, char **argv)
{
  int   c, flags;
  mqd_t mqd;

  flags = O_RDWR ;
  while ( (c = getopt(argc, argv, "n")) != -1) {
        switch (c) {
            case 'n': flags |= O_NONBLOCK;
                  break;
        }
  }
  if (optind != argc - 1)
        err_quit("usage: msqcl  <name>");
  mqd = mq_open(argv[optind], flags);
  if ( mqd < 0) err_sys("error mq_open");
  if (fork())
     mqwrite(mqd,argv[optind]);
  else
     mqread(mqd,argv[optind]);
  exit(0);
}
