#include "myipc.h"
/* Threads */
#include <pthread.h>
pthread_t       threadread, threadwrite;

/* read from Messagequeue */
void msg_read(int *mqd)
{
  int lgt,n;
  char buf[128];
  unsigned prio;
  struct mq_attr attr;

  while(1) {
          mq_getattr(*mqd,&attr);
          if ((lgt=mq_receive(*mqd,buf,attr.mq_msgsize,&prio)) <= 0) break;
          write (1,"\n",1);
          write(1,buf,lgt);
          write(1,"s> ",3);
  }
  err_sys("EOF");
  write(1,"end\n",4);
  pthread_cancel(threadwrite);
  n=0;
  pthread_exit(&n);

}
/* write in Messagequeue */
void msg_write( int *mqd)
{
  int lgt,n;
  char buf[128];
  unsigned prio;

  while (1) {
    write(1,"S> ",3);
    prio=SND;
    if ((lgt = read(0,buf,128)) <= 0) break;
         mq_send(*mqd, buf, lgt, prio);
  }
  pthread_cancel(threadread);
  n=0;
  pthread_exit(&n);
}

struct mq_attr attr;

int main(int argc, char *argv[])
{
  int c, flags;
  char second[128];
  mqd_t mqdr, mqdw;
  
  flags = O_RDWR | O_CREAT;
  while ( (c = getopt(argc, argv, "em:z:")) != -1) {
        switch (c) {
        case 'e':
                flags |= O_EXCL; break;
        case 'm':
                attr.mq_maxmsg = atol(optarg); break;
        case 'z':
                attr.mq_msgsize = atol(optarg); break;
        }
  }
  if (optind != argc - 1)
        err_quit("usage: server [ -e ] [ -m maxmsg -z msgsize ] <name>");
  if ((attr.mq_maxmsg != 0 && attr.mq_msgsize == 0) ||
        (attr.mq_maxmsg == 0 && attr.mq_msgsize != 0))
        err_quit("must specify both -m maxmsg and -z msgsize");
  flags = O_WRONLY | O_CREAT;
  mqdw = mq_open(argv[optind], flags, (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH),
                          (attr.mq_maxmsg != 0) ? &attr : NULL);
  if ( mqdw < 0) err_sys("error mq_open - write");
  strcpy(second,argv[optind]);
  strcat(second,"1");
  flags = O_RDONLY | O_CREAT;
  mqdr = mq_open(second, flags, (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH),
                          (attr.mq_maxmsg != 0) ? &attr : NULL);
  if ( mqdr < 0) err_sys("error mq_open - read");

  pthread_create(&threadread,NULL, (void *) msg_read, 
                 (void *) &mqdr );
  pthread_create(&threadwrite,NULL, (void *) msg_write, 
                  (void *) &mqdw );
  pthread_join(threadread, NULL);
  pthread_join(threadwrite, NULL);
  mq_unlink(argv[optind]);
  exit(0);
}
