#include  "myipc.h"
#define  NAME  "testeintr"
static void  sig_alrm(int);

int main(int argc, char **argv)
{
  sem_t  *sem1, sem2;

  /* first test a named semaphore */
  sem_unlink(NAME);
  sem1 = sem_open(NAME, O_RDWR | O_CREAT | O_EXCL, FILE_MODE, 0);
  if ( sem1 < 0 ) err_sys("sem_opne");
  signal(SIGALRM, sig_alrm);
  alarm(2);
  printf("Setze Alarm auf 2 Sekunden fuer sem1\n");
  if (sem_wait(sem1) == 0)
    printf("sem_wait returned 0?\n");
  else
    err_ret("sem_wait error");
  sem_close(sem1);

  /* now a memory-based semaphore with process scope */
  sem_init(&sem2, 1, 0);
  alarm(2);
  printf("Setze Alarm auf 2 Sekunden fuer sem2\n");
  if (sem_wait(&sem2) == 0)
    printf("sem_wait returned 0?\n");
  else
    err_ret("sem_wait error");
  sem_destroy(&sem2);

  exit(0);
}

static void
sig_alrm(int signo)
{
  signal(SIGALRM, sig_alrm);
  printf("SIGALRM caught\n");
  return;
}
