
#include	<sys/types.h>	/* basic system data types */
#include	<sys/stat.h>	/* for S_xxx file mode constants */
#include	<sys/time.h>	/* timeval{} for select() */
#include	<wait.h>		/* timespec{} for pselect() */
#include	<time.h>		/* timespec{} for pselect() */
#include	<errno.h>
#include	<fcntl.h>		/* for nonblocking */
#include	<limits.h>		/* PIPE_BUF */
#include	<signal.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<unistd.h>
#include        <pthread.h>
#include	<mqueue.h>
#include	<semaphore.h>
#include	<sys/mman.h>

#define FILE_MODE (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH )
#define min(a,b)        ((a) < (b) ? (a) : (b))
#define max(a,b)        ((a) > (b) ? (a) : (b))

extern void err_sys(char *s);
                         
int
sleep_us(unsigned int nusecs)
{
	struct timeval	tval;

	if (nusecs == 0)
		return(0);

	for ( ; ; ) {
		tval.tv_sec = nusecs / 1000000;
		tval.tv_usec = nusecs % 1000000;
		if (select(0, NULL, NULL, NULL, &tval) == 0)
			return(0);		/* all OK */
		/*
		 * Note than on an interrupted system call there's not
		 * much we can do, since the timeval{} isn't updated with the time
		 * remaining.  We could obtain the clock time before the call, and
		 * then obtain the clock time here, subtracting them to determine
		 * how long select() blocked before it was interrupted, but that
		 * seems like too much work :-)
		 */
		if (errno != EINTR)
			return(-1);
		/* else go around again */
	}
}

void
Sleep_us(unsigned int nusecs)
{
	if (sleep_us(nusecs) == -1)
		err_sys("sleep_us error");
}
