#include	"myipc.h"

int
main(int argc, char **argv)
{
	int		fd, i;
	char	*ptr;
	size_t	shmsize, mmapsize, pagesize;

	if (argc != 4)
		err_quit("usage: test1 <name> <shmsize> <mmapsize>");
	shmsize = atoi(argv[2]);
	mmapsize = atoi(argv[3]);

    /* open shm: create or truncate; set shm size */
	fd = shm_open(argv[1], O_RDWR | O_CREAT | O_TRUNC,
				  FILE_MODE);
        if ( fd < 0 ) err_sys("shm_open");
	ftruncate(fd, shmsize);
	ptr = mmap(NULL, mmapsize, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
        if ( ptr == MAP_FAILED ) err_sys("mmap");
	close(fd);

	pagesize = sysconf(_SC_PAGESIZE);
	printf("PAGESIZE = %ld\n", (long) pagesize);

	for (i = 0; i < max(shmsize, mmapsize); i += pagesize) {
		printf("ptr[%d] = %d\n", i, ptr[i]);
		ptr[i] = 1;
		printf("ptr[%d] = %d\n", i + (int) pagesize - 1, ptr[i + pagesize - 1]);
		ptr[i + pagesize - 1] = 1;
	}
	printf("ptr[%d] = %d\n", i, ptr[i]);
	
	exit(0);
}
